#ifndef ZTM_DEF
#define ZTM_DEF
using namespace std;

#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include "Def.h"
#include <math.h>


/**MACROS**/


#define TOTAL_OBJECTS (256)

#define tolfac (70*65536)  //tolerance factor for the textures
#define length_tolerance (512*65536)
#define polygon_tolerance (65)

#define ZT_SQR(a) (a*a)

/** YOU CAN CHANGE PDATA HERE TO SOMETHING ELSE, SUCH AS XPDATA **/
#define vPDATA XPDATA

#define USE_PALETTE
/*********************************************************/


typedef unsigned short jo_color;
typedef float normArr[3];

typedef struct
{
    int x;
    int y;
    int z;
} vector3;

typedef struct
{
    short x;
    short y;
    short z;
} vector3s;

typedef struct
{
    int x;
    int y;
    int z;
    int length;
} vector4;

typedef struct
{
    vector3 MaxValue;
    vector3 MinValue;
    vector3 Rotation;
    int     MaskID;
} _BB_Hitbox;

typedef struct {
    vector3 pos;
    vector3 len;
    Sint32	att;
} COLLISION; //20 bytes

typedef struct {
	Uint32		 nbCo;
	COLLISION	*cotbl;
}CDATA;


/*****************************************
* Instead of taking 12 bytes per vertices, we use 8, plus data in quad data
* 3x2 bytes for XYZ, 2 bytes for the buffer reference ID
* The idea is as follow : instead of multiplicating vertices as
* you subdivide the map for culling, we use a buffer and look-up tables
* Warning : Still testing the actual speed, might need to be transfered to High-Work RAM
* TODO : Test, test and more testing
***************************************/


typedef Sint16 compVert[XYZ];
typedef Uint8 compNorm;

typedef struct
{
    compVert cVert[2000];  //Uncompressed for now
    // cVert[2000][XYZS]; //LAZY WAY!
   // short * cVert[XYZS]; //compressed TRANSLATION value for vertices : MSB = sign, 7 remaining bits as 6.1 fixed point (shift left 15)
   // char normIdx; //From a per verticle normal index (same as MD2 format)
   compNorm cNorm[2000];
}key_frame_t;
/*
typedef struct
{
  //key_frame_t * PDATA_KeyFrames;
  key_frame_t PDATA_KeyFrames[25]; //LAZY WAY!
} anim_struct;*/

typedef struct
{
    unsigned short  TOTAL_MESH;
    short           TOT_TEXT;
    unsigned int    TEXT_SIZE;  //to quickly load from disk
    unsigned int    PDATA_SIZE; //to quickly load from disk
    vector3 Origin; //Origin point used to "center" the collision data and your position with the current grid
    vector3 Length;
    vPDATA pol[TOTAL_OBJECTS];
    //vPDATA anim_pol[TOTAL_OBJECTS];
    //unsigned int DUMMY;
    unsigned short nbFrames;
    unsigned short framerate; //Interpolation factor of 2, means the number of frames between 2 key frames
    key_frame_t *  animation;

   // anim_struct  animation[240]; //LAZY WAY!
} _MOD_DATA;



/**Old image structure, will be ditched for ZTE img_t type**/
typedef struct
{
	unsigned short	width;
	unsigned short	height;
	jo_color    data[320*320]; //It means maximum texture resolution of 128*128, but at that resolution the Saturn is struggling anyways, so avoid using it
}					jo_img;  //For compatibility with JO ENGINE image format

typedef struct
{
    unsigned short width;
    unsigned short height;
    unsigned short palette_id[256*256];  //4 bits per pixel after conversion.
    unsigned short palette[16];
} img_4_bpp;



typedef struct
{
    Uint16      width;
    Uint16      height;
    Uint16	    cmode ;	//Color type : 16 or 256
    Uint16      nbcol;
    Uint16  *   data;  //The palette index for the pixels. If CLUT, palette right after the data
} img_t;



/*****GLOBALS*******/
/*extern vPDATA mesh_array[TOTAL_OBJECTS];
extern vPDATA LOD_mesh[TOTAL_OBJECTS];
extern _MOD_DATA MAP_DATA;*/
extern string PdataName[TOTAL_OBJECTS];

/*****FUNCTIONS*****/

#include "tools.h"
#include "load.h"
#include "collision.h"
#include "textures.h"
#include "writeBinary.h"
#include "writeHeader.h"


/**Main (just for quick reference)**/
void specialConditions(unsigned short startPtr, unsigned short endPtr, _MOD_DATA * model);


#endif
