#include "ZTM_DEF.h"
/*****
CREDIT FOR TGA LOADING FUNCTIONS : JOHANNES FETZ, JO ENGINE
DIRTY ADAPTATION BY XL2
******/

/**GLOBALS**/
ATTR        TextureAttributeArray[1280];
char        TextureSpecialAttribute[1280];
string      TextureArray[1280]={""};
jo_img      img[1280];
img_4_bpp   pimg[1280];
/**END OF GLOBAL VARIABLES**/






#define			JO_TGA_CONVERT_COLOR(TGA, IDX)		        (((*((unsigned char *)(TGA + IDX))))/8 & 0x1f)

#define R_COLOR_COMPRESSION (1)
#define G_COLOR_COMPRESSION (1)
#define B_COLOR_COMPRESSION (1)

#define         JO_TGA_RGB(R, G, B)		                    (0x8000 | ((((B/B_COLOR_COMPRESSION)*B_COLOR_COMPRESSION)<<10) | (((G/G_COLOR_COMPRESSION)*G_COLOR_COMPRESSION) << 5) | (R/R_COLOR_COMPRESSION)*R_COLOR_COMPRESSION))

#define			JO_TGA_24BITS_GET_PIXEL(TGA, X, Y, WIDTH)	JO_TGA_RGB(JO_TGA_CONVERT_COLOR(TGA, (((X) * 3) + 2) + ((Y) * (WIDTH * 3))), \
                                                                JO_TGA_CONVERT_COLOR(TGA, (((X) * 3) + 1) + ((Y) * (WIDTH * 3))), \
                                                                JO_TGA_CONVERT_COLOR(TGA, (((X) * 3)) + ((Y) * (WIDTH * 3))))

#define			JO_TGA_32BITS_GET_PIXEL(TGA, X, Y, WIDTH)	JO_TGA_RGB(JO_TGA_CONVERT_COLOR(TGA, ((4*X) + 2) + ((Y) * (4*WIDTH))), \
                                                                JO_TGA_CONVERT_COLOR(TGA, ((4*X) + 1) + ((Y) * (4*WIDTH))), \
                                                                JO_TGA_CONVERT_COLOR(TGA, ((4*X) + 0) + ((Y) * (4*WIDTH))))




/**** Bytes alignment can be problematic, and since I'm only trying to read the file format, I just went all-short to save time  ****/
typedef struct
{
   unsigned short  idlength;
   unsigned short  colourmaptype;
   unsigned short  datatypecode;
   short colourmaporigin;
   short colourmaplength;
   unsigned short  colourmapdepth;
   short x_origin;
   short y_origin;
   short width;
   short height;
   unsigned short  bitsperpixel;
   unsigned short  imagedescriptor;
} TGA_HEADER;





/****/
Uint16 CompressColor(Uint16 color, int compression)
{
    if (color == 0)
        return 0;
    else
        return color & (64478<<(compression));
}


/**This function fills the current image's palette in a 16 colors palette**/
void FillPalette(jo_img * source, img_4_bpp * dest, int compression){
    for (unsigned int i=0; i<16; i++) dest->palette[i]=0x00;
    dest->width=source->width; dest->height=source->height;
    unsigned short total_palette = 0;

    /**First pass to reserve the first palette entry for transparency, only if transparency is used**/
    for (unsigned int i=0; i< (unsigned int)(source->width*source->height); i++)
    {
        if (source->data[i]==0)
        {
            total_palette=1;
            dest->palette[0]=0;
            //break;
        }
        if (compression>=0)
        {
            source->data[i] = CompressColor(source->data[i], compression);
        }
        if (compression>12) return;
    }

    for (unsigned int i=0; i< (unsigned int)(source->width*source->height); i++)
    {
        bool duplicate=false;
        for (unsigned short ii=0; ii<total_palette; ii++){
            if (source->data[i] == dest->palette[ii]){
                duplicate = true;
                dest->palette_id[i]=ii;
                break;
            }
        }
        if (duplicate == false){
            if (total_palette >= 16)
                {dest->palette_id[i]=15; total_palette++;}
            else{
                dest->palette_id[i]=total_palette;
                dest->palette[total_palette]=source->data[i];
                total_palette++;
            }
        }
    }
    if (total_palette > 16)
    {
        int compr=compression + 1;
        //if (compr == 0) cout << "This image contains more than 16 colors.\nCompressing the color data...\n";
        //cout << "Compression level : " << compr << "\n";
        FillPalette(source, dest, compr);
    }
    else
    {
        if (compression >=0)
            cout << "The image contains a total of " << total_palette << " colors after compression.\n";
        else
            cout << "The image contains a total of " << total_palette << " colors.\n";
    }
}


int ReadTGAHeader(ifstream *ibinfile, TGA_HEADER * header)
{
    ibinfile->read((char*)&header->idlength, sizeof(unsigned char));
    ibinfile->read((char*)&header->colourmaptype, sizeof(unsigned char));
    ibinfile->read((char*)&header->datatypecode, sizeof(unsigned char));
    ibinfile->read((char*)&header->colourmaporigin, sizeof(short));
    ibinfile->read((char*)&header->colourmaplength, sizeof(short));
    ibinfile->read((char*)&header->colourmapdepth, sizeof(unsigned char));
    ibinfile->read((char*)&header->x_origin, sizeof(short));
    ibinfile->read((char*)&header->y_origin, sizeof(short));
    ibinfile->read((char*)&header->width, sizeof(short));
    ibinfile->read((char*)&header->height, sizeof(short));
    ibinfile->read((char*)&header->bitsperpixel, sizeof(unsigned char));
    ibinfile->read((char*)&header->imagedescriptor, sizeof(unsigned char));
    return 1;
}


Uint16         jo_tga_get_pixel(const char * const stream, const int x, const int y, const int width, unsigned short bits)
{
    switch (bits)
    {
        case 32:
            if (JO_TGA_CONVERT_COLOR(stream, (4*(x) + 3) + ((y) * 4*(width))) <= 0)
                return (0);
            return (JO_TGA_32BITS_GET_PIXEL(stream, x, y, width));
        default:
            return (JO_TGA_24BITS_GET_PIXEL(stream, x, y, width));
    }
}


int ReadTGAData(ifstream * file, jo_img * img, unsigned short bits)
{

    for (int y=img->height-1; y>=0 ; y--)  //This is actually the right order
    //for (int y=0; y<img->height ; y++)
    {
         for (int x=0; x< img->width; x++)
        {
            if (bits==32)
            {
                char stream[4] = {0};
                file->read((char*)&stream, (4));
                if (JO_TGA_CONVERT_COLOR(stream, 3) <= 0) img->data[(y*img->width)+x]=0;
                else
                    img->data[(y*img->width)+x] = JO_TGA_32BITS_GET_PIXEL(stream,0,0, 4);
            }
            else if (bits==24)
            {
                char stream[3] = {0};
                file->read((char*)&stream, (3));
                img->data[(y*img->width)+x] = JO_TGA_24BITS_GET_PIXEL(stream, 0, 0, 3);
            }
        }
    }
    return 1;
}

int ReadTGAFile (string folder, string filename, unsigned int texture_id, _MOD_DATA * model)
{

    //cout << "\nAttempting to read TGA texture files...\n";
    string name;
    name =  folder + filename + ".TGA"; //Temporary : Will break under several conditions
    TGA_HEADER header;
    ifstream ibinfile(name.c_str(), ios::in | ios::binary);

    if (!ibinfile.is_open()) {cout << "ERROR : COULDN'T LOAD FILE " << filename.c_str() << ".TGA\n"; return -1;}

    ReadTGAHeader(&ibinfile, &header);
        cout << "Texture " << filename << ", size : " << header.width << "x" << header.height << ", pixel depth : " << header.bitsperpixel << ", RLE = " << header.datatypecode << "\n";
    img[texture_id].width = header.width;
    img[texture_id].height = header.height;

    model->TEXT_SIZE += (header.width*header.height/2)+32+12;  //+40, 32 bytes for the palette, 8 bytes for the img data (width, height and a pointer)

    ReadTGAData(&ibinfile, &img[texture_id], header.bitsperpixel);
    ibinfile.close();

    FillPalette(&img[texture_id], &pimg[texture_id], -1);
    return 7777;
}

