
#include "Headers/ZTM_DEF.h"


unsigned short  swap_endian_ushort(unsigned short value) { return ((((value) >> 8) & 0xff) | (((value) & 0xff) << 8));}
short           swap_endian_sshort(short value) { return ((value >> 8) | (value << 8));}
unsigned int    swap_endian_uint(unsigned int value) { return ((((value) & 0xff000000) >> 24) | (((value) & 0x00ff0000) >>  8) | (((value) & 0x0000ff00) <<  8) | (((value) & 0x000000ff) << 24)); }
int             swap_endian_sint(int value) { return ((((value) & 0xff000000) >> 24) | (((value) & 0x00ff0000) >>  8) | (((value) & 0x0000ff00) <<  8) | (((value) & 0x000000ff) << 24)); }

int ztInnerProduct(VECTOR vct1, VECTOR vct2){return vct1[X]*vct2[X]+vct1[Y]*vct2[Y]+vct1[Z]*vct2[Z];}
int ztInnerProductF(normArr vct1, normArr vct2){return vct1[X]*vct2[X]+vct1[Y]*vct2[Y]+vct1[Z]*vct2[Z];}

vector3 ReturnBBCenter(_BB_Hitbox * currentBB)
{
    vector3 centerPt;
    centerPt.x = currentBB->MinValue.x+((currentBB->MaxValue.x - currentBB->MinValue.x)/2);
    centerPt.y = currentBB->MinValue.y+((currentBB->MaxValue.y - currentBB->MinValue.y)/2);
    centerPt.z = currentBB->MinValue.z+((currentBB->MaxValue.z - currentBB->MinValue.z)/2);
    return centerPt;
}

bool CheckPointInBB(vector3 * centerPt, _BB_Hitbox * currentBB)
{
     if ((centerPt->x >= currentBB->MinValue.x) && (centerPt->x < currentBB->MaxValue.x)
                    && (centerPt->y >= currentBB->MinValue.y) && (centerPt->y < currentBB->MaxValue.y)
                    && (centerPt->z >= currentBB->MinValue.z) && (centerPt->z < currentBB->MaxValue.z))
                    return true;
    else return false;
}

bool CheckPointInBv(vector3 * pt, vector4 * bv)
{
    if ((pt->x >= bv->x - bv->length) && (pt->x < bv->x+bv->length)
        && (pt->y >= bv->y - bv->length) && (pt->y < bv->y+bv->length)
        && (pt->z >= bv->z - bv->length) && (pt->z < bv->z+bv->length))
            return true;
    else return false;
}

bool CheckSamePlane(POINT TestedPoint, POINT PlanePt2, VECTOR TestedNormal, VECTOR PlaneNormal)
{
    VECTOR ptVector;
    ptVector[0] = TestedPoint[0] - PlanePt2[0];
    ptVector[1] = TestedPoint[1] - PlanePt2[1];
    ptVector[2] = TestedPoint[2] - PlanePt2[2];

    const int Norm_tolerance = 500; //Tolerance for normals (to get around problems with source .OBJ file)
    const int InProd_tolerance = 65536*5; //Tolerance for innerproduct (65536 * tolerance) -> could lead to small graphical glitches, but prevents having only 1-2 quads per plane

    if (-InProd_tolerance <= ztInnerProduct(ptVector, PlaneNormal) && (InProd_tolerance >= ztInnerProduct(ptVector, PlaneNormal)) &&
        (TestedNormal[X]<=PlaneNormal[X]+Norm_tolerance) && (TestedNormal[X]>=PlaneNormal[X]-Norm_tolerance) &&
        (TestedNormal[Y]<=PlaneNormal[Y]+Norm_tolerance) && (TestedNormal[Y]>=PlaneNormal[Y]-Norm_tolerance) &&
        (TestedNormal[Z]<=PlaneNormal[Z]+Norm_tolerance) && (TestedNormal[Z]>=PlaneNormal[Z]-Norm_tolerance))
        return true;
    else
        return false;
}

bool CheckInFrontPlane(POINT camPt, POINT PlanePt1, VECTOR PlaneNormal)
{
    VECTOR ptVector;
    ptVector[0] = -camPt[0] - PlanePt1[0];
    ptVector[1] = -camPt[1] - PlanePt1[1];
    ptVector[2] = -camPt[2] - PlanePt1[2];

    return 0 < ztInnerProduct(ptVector, PlaneNormal);
}

int AddPoint(vPDATA * newMesh, POINT CurrentPoint, VECTOR CurNormVect)
{
    for (unsigned int i=0; i< newMesh->nbPoint; i++)
    {
        if ((newMesh->pntbl[i][0] == CurrentPoint[0])&& (newMesh->pntbl[i][1]== CurrentPoint[1]) && (newMesh->pntbl[i][2]== CurrentPoint[2]))
            {
                return i;
            }
    }

    newMesh->pntbl[newMesh->nbPoint][X] = CurrentPoint[0];
    newMesh->pntbl[newMesh->nbPoint][Y] = CurrentPoint[1];
    newMesh->pntbl[newMesh->nbPoint][Z] = CurrentPoint[2];
    newMesh->vntbl[newMesh->nbPoint][X] = CurNormVect[X];
    newMesh->vntbl[newMesh->nbPoint][Y] = CurNormVect[Y];
    newMesh->vntbl[newMesh->nbPoint][Z] = CurNormVect[Z];
    newMesh->nbPoint ++;
    return (newMesh->nbPoint - 1);
}
/*
int AddPoint(vPDATA * newMesh, POINT CurrentPoint)
{
    for (unsigned int i=0; i< newMesh->nbPoint; i++)
    {
        if ((newMesh->pntbl[i][0] == CurrentPoint[0])&& (newMesh->pntbl[i][1]== CurrentPoint[1]) && (newMesh->pntbl[i][2]== CurrentPoint[2]))
            {
                return i;
            }
    }

    newMesh->pntbl[newMesh->nbPoint][0] = CurrentPoint[0];
    newMesh->pntbl[newMesh->nbPoint][1] = CurrentPoint[1];
    newMesh->pntbl[newMesh->nbPoint][2] = CurrentPoint[2];
    newMesh->nbPoint ++;
    return (newMesh->nbPoint - 1);
}*/

void copyHitbox(_BB_Hitbox * dest, _BB_Hitbox * source)
{
    dest->MaskID=source->MaskID;
    dest->MaxValue.x=source->MaxValue.x;
    dest->MaxValue.y=source->MaxValue.y;
    dest->MaxValue.z=source->MaxValue.z;
    dest->MinValue.x=source->MinValue.x;
    dest->MinValue.y=source->MinValue.y;
    dest->MinValue.z=source->MinValue.z;
    dest->Rotation.x=source->Rotation.x;
    dest->Rotation.y=source->Rotation.y;
    dest->Rotation.z=source->Rotation.z;
}


void createLocalAABB(vPDATA * orMesh, _BB_Hitbox * currentBB)
{
    _BB_Hitbox bufBB;
    bufBB.MinValue.x = currentBB->MaxValue.x;
    bufBB.MinValue.y = currentBB->MaxValue.y;
    bufBB.MinValue.z = currentBB->MaxValue.z;
    bufBB.MaxValue.x = currentBB->MinValue.x;
    bufBB.MaxValue.y = currentBB->MinValue.y;
    bufBB.MaxValue.z = currentBB->MinValue.z;
    bufBB.Rotation.x = 0; bufBB.Rotation.y = 0; bufBB.Rotation.z = 0;
    bufBB.MaskID = 0;

    vector3 bufPoint;
    for (unsigned int i=0; i<orMesh->nbPoint; i++)
    {
        bufPoint.x = orMesh->pntbl[i][0]; bufPoint.y=orMesh->pntbl[i][1]; bufPoint.z=orMesh->pntbl[i][2];
        if (CheckPointInBB(&bufPoint, currentBB)==true)
        {
            if (orMesh->pntbl[i][0] > bufBB.MaxValue.x) bufBB.MaxValue.x = orMesh->pntbl[i][0];
            if (orMesh->pntbl[i][0] < bufBB.MinValue.x) bufBB.MinValue.x = orMesh->pntbl[i][0];
            if (orMesh->pntbl[i][1] > bufBB.MaxValue.y) bufBB.MaxValue.y = orMesh->pntbl[i][1];
            if (orMesh->pntbl[i][1] < bufBB.MinValue.y) bufBB.MinValue.y = orMesh->pntbl[i][1];
            if (orMesh->pntbl[i][2] > bufBB.MaxValue.z) bufBB.MaxValue.z = orMesh->pntbl[i][2];
            if (orMesh->pntbl[i][2] < bufBB.MinValue.z) bufBB.MinValue.z = orMesh->pntbl[i][2];
        }
    }
    copyHitbox(currentBB, &bufBB);

}


_BB_Hitbox ReturnPolyBounds(vPDATA * currentMesh, int idx)
{
    _BB_Hitbox tempBB;
    tempBB.MinValue.x = 2147483647; tempBB.MinValue.y = 2147483647; tempBB.MinValue.z = 2147483647;
    tempBB.MaxValue.x = -2147483647;  tempBB.MaxValue.y = -2147483647;  tempBB.MaxValue.z = -2147483647;

    for (int i=0; i<4; i++)
    {
        if (currentMesh->pntbl[currentMesh->pltbl[idx].Vertices[i]][0] < tempBB.MinValue.x) tempBB.MinValue.x = currentMesh->pntbl[currentMesh->pltbl[idx].Vertices[i]][0];
        if (currentMesh->pntbl[currentMesh->pltbl[idx].Vertices[i]][1] < tempBB.MinValue.y) tempBB.MinValue.y = currentMesh->pntbl[currentMesh->pltbl[idx].Vertices[i]][1];
        if (currentMesh->pntbl[currentMesh->pltbl[idx].Vertices[i]][2] < tempBB.MinValue.z) tempBB.MinValue.z = currentMesh->pntbl[currentMesh->pltbl[idx].Vertices[i]][2];
        if (currentMesh->pntbl[currentMesh->pltbl[idx].Vertices[i]][0] > tempBB.MaxValue.x) tempBB.MaxValue.x = currentMesh->pntbl[currentMesh->pltbl[idx].Vertices[i]][0];
        if (currentMesh->pntbl[currentMesh->pltbl[idx].Vertices[i]][1] > tempBB.MaxValue.y) tempBB.MaxValue.y = currentMesh->pntbl[currentMesh->pltbl[idx].Vertices[i]][1];
        if (currentMesh->pntbl[currentMesh->pltbl[idx].Vertices[i]][2] > tempBB.MaxValue.z) tempBB.MaxValue.z = currentMesh->pntbl[currentMesh->pltbl[idx].Vertices[i]][2];
    }

    return tempBB;
}

void copyMesh(vPDATA * dest, vPDATA * source)
{

    for (unsigned int i=0; i< source->nbPolygon; i++)
    {
        int totPol=dest->nbPolygon;
        for (unsigned int j=0; j<4; j++)
        {
            int tempPoint= AddPoint(dest,(source->pntbl[source->pltbl[i].Vertices[j]]), (source->vntbl[source->pltbl[i].Vertices[j]]));
            dest->pltbl[totPol].Vertices[j]=tempPoint;
        }
        dest->pltbl[totPol].norm[0] = source->pltbl[i].norm[0];
        dest->pltbl[totPol].norm[1] = source->pltbl[i].norm[1];
        dest->pltbl[totPol].norm[2] = source->pltbl[i].norm[2];
        dest->attbl[totPol]=source->attbl[i];
        dest->nbPolygon++;
    }
}
/*
void copyMesh(vPDATA * dest, vPDATA * source)
{

    for (unsigned int i=0; i< source->nbPolygon; i++)
    {
        int totPol=dest->nbPolygon;
        for (unsigned int j=0; j<4; j++)
        {
            int tempPoint= AddPoint(dest,(source->pntbl[source->pltbl[i].Vertices[j]]));
            dest->pltbl[totPol].Vertices[j]=tempPoint;
        }
        dest->pltbl[totPol].norm[0] = source->pltbl[i].norm[0];
        dest->pltbl[totPol].norm[1] = source->pltbl[i].norm[1];
        dest->pltbl[totPol].norm[2] = source->pltbl[i].norm[2];

        dest->vntbl[totPol][X]=source->vntbl[i][X];
        dest->vntbl[totPol][Y]=source->vntbl[i][Y];
        dest->vntbl[totPol][Z]=source->vntbl[i][Z];

        dest->attbl[totPol]=source->attbl[i];
        dest->nbPolygon++;
    }
}*/


unsigned int count_poly_with_bv(vPDATA * pol, vector4 * bv)
{
    unsigned int cntr = 0;

    for (unsigned int i=0; i < pol->nbPolygon; i++)
    {
        _BB_Hitbox tempBB = ReturnPolyBounds(pol, i);
        vector3 centerPt = ReturnBBCenter(&tempBB);
        if (CheckPointInBv(&centerPt, bv)==true)
        {
            cntr++;
        }
    }
    return cntr;
}


unsigned int countPolygon(vPDATA * originalMesh, _BB_Hitbox * TempMeshBB)
{
    unsigned int cntr = 0;

    for (unsigned int i=0; i<originalMesh->nbPolygon; i++)
    {
        _BB_Hitbox tempBB = ReturnPolyBounds(originalMesh, i);
        vector3 centerPt = ReturnBBCenter(&tempBB);
        if (CheckPointInBB(&centerPt, TempMeshBB)== true)
        {
            cntr ++;
        }
    }
    return cntr;
}



void VecNormal(FIXED * dest, float a[3], float b[3] )
{
	/**Cross product**/
	float buf[XYZ];

    buf[X]= (((a[Y])*(b[Z])) - ((a[Z])*(b[Y])));
    buf[Y]= (((a[Z])*(b[X])) - ((a[X])*(b[Z])));
    buf[Z]= (((a[X])*(b[Y])) - ((a[Y])*(b[X])));

    float dist=sqrt((buf[X]*buf[X])+(buf[Y]*buf[Y])+(buf[Z]*buf[Z]));

    if (dist==0)
    {
        dest[X]=0; dest[Y]=0; dest[Z]=0;
        return;
    }
    else
    {
        dest[X]= toFIXED(buf[X]/dist);
        dest[Y]= toFIXED(buf[Y]/dist);
        dest[Z]= toFIXED(buf[Z]/dist);
    }
}

void VecEdge(float * dest, FIXED fa[3], FIXED fb[3])
{
    float a[XYZ];    a[X] = toFLOAT(fa[X]);     a[Y] = toFLOAT(fa[Y]);  a[Z] = toFLOAT(fa[Z]);
    float b[XYZ];    b[X] = toFLOAT(fb[X]);     b[Y] = toFLOAT(fb[Y]);  b[Z] = toFLOAT(fb[Z]);

    dest[X] = (a[X]-b[X]);
    dest[Y] = (a[Y]-b[Y]);
    dest[Z] = (a[Z]-b[Z]);
}

void RECALCULATE_NORMALS(vPDATA * pol)
{
    FIXED v0[3], v1[3], v2[3], v3[3];
    float vN[3];
    float vU[3], vV[3];


    for (unsigned int i=0; i<pol->nbPolygon; i++)
    {
        VecEdge(vU, pol->pntbl[pol->pltbl[i].Vertices[0]], pol->pntbl[pol->pltbl[i].Vertices[3]]);
        VecEdge(vV, pol->pntbl[pol->pltbl[i].Vertices[1]], pol->pntbl[pol->pltbl[i].Vertices[0]]);
        VecNormal(v0,vV,vU);

        VecEdge(vU, pol->pntbl[pol->pltbl[i].Vertices[1]], pol->pntbl[pol->pltbl[i].Vertices[0]]);
        VecEdge(vV, pol->pntbl[pol->pltbl[i].Vertices[2]], pol->pntbl[pol->pltbl[i].Vertices[1]]);
        VecNormal(v1,vV, vU);

        VecEdge(vU, pol->pntbl[pol->pltbl[i].Vertices[2]], pol->pntbl[pol->pltbl[i].Vertices[1]]);
        VecEdge(vV, pol->pntbl[pol->pltbl[i].Vertices[3]], pol->pntbl[pol->pltbl[i].Vertices[2]]);
        VecNormal(v2,vV,vU);

        VecEdge(vU, pol->pntbl[pol->pltbl[i].Vertices[3]], pol->pntbl[pol->pltbl[i].Vertices[2]]);
        VecEdge(vV, pol->pntbl[pol->pltbl[i].Vertices[0]], pol->pntbl[pol->pltbl[i].Vertices[3]]);
        VecNormal(v3,vV,vU);

        vN[X]=toFLOAT(v0[X]+v1[X]+v2[X]+v3[X]);
        vN[Y]=toFLOAT(v0[Y]+v1[Y]+v2[Y]+v3[Y]);
        vN[Z]=toFLOAT(v0[Z]+v1[Z]+v2[Z]+v3[Z]);

        float dist=sqrt((vN[X]*vN[X])+(vN[Y]*vN[Y])+(vN[Z]*vN[Z]));

        if (dist==0) {vN[X]=0; vN[Y]=0; vN[Z]=0;}
        else        {
            vN[X]= (vN[X]/dist);
            vN[Y]= (vN[Y]/dist);
            vN[Z]= (vN[Z]/dist);
        }
        for (unsigned int ii=0; ii<3; ii++)
            pol->pltbl[i].norm[ii]= toFIXED(vN[ii]);
    }
}

void VECTOR_NORMAL(vPDATA * pol)
{
    FIXED vN[3], v0[3]; //, v1[3], v2[3], v3[3],
    float vU[3], vV[3];
    //vV[X]=0.0f; vV[Y]=-30.5f; vV[Z]=0.0f;

    for (unsigned int i=0; i<pol->nbPoint; i++)
    {
        VECTOR v_array[100];
        unsigned int nbVectors=0;

        for (unsigned int ii=0; ii<pol->nbPolygon; ii++)
        {
            for (unsigned int j=0; j<4; j++)
            {
                if (i == pol->pltbl[ii].Vertices[j])
                {
                    v_array[nbVectors][X]=pol->pltbl[ii].norm[X];
                    v_array[nbVectors][Y]=pol->pltbl[ii].norm[Y];
                    v_array[nbVectors][Z]=pol->pltbl[ii].norm[Z];
                    nbVectors++;
                }
            }
        }

        float vnTot[XYZ] = {0};
        for (unsigned int ii=0; ii<nbVectors; ii++)
        {
            vnTot[X]+=toFLOAT(v_array[ii][X]);
            vnTot[Y]+=toFLOAT(v_array[ii][Y]);
            vnTot[Z]+=toFLOAT(v_array[ii][Z]);
        }

        if (nbVectors > 0)
        {
            vN[X]=toFIXED(vnTot[X]/(float)nbVectors);
            vN[Y]=toFIXED(vnTot[Y]/(float)nbVectors);
            vN[Z]=toFIXED(vnTot[Z]/(float)nbVectors);
        }
        else
        {
            vN[X]=0; vN[Y]=0; vN[Z]=0;
        }



        /*vU[X]= toFLOAT(pol->pntbl[i][X]);
        vU[Y]= toFLOAT(pol->pntbl[i][Y]);
        vU[Z]= toFLOAT(pol->pntbl[i][Z]);

        VecEdge(vU, pol->pntbl[i], (0,0,0));
        VecEdge(vV, pol->pntbl[pol->pltbl[i].Vertices[1]], pol->pntbl[pol->pltbl[i].Vertices[0]]);
        //VecNormal(vN,vU,vV);

        FIXED dist=sqrt((vU[X]*vU[X])+(vU[Y]*vU[Y])+(vU[Z]*vU[Z]));
        if (dist==0)
        {
            vN[X]=0; vN[Y]=0; vN[Z]=0;
            return;
        }
        else
        {
            vN[X]= toFIXED(vU[X]/dist);
            vN[Y]= toFIXED(vU[Y]/dist);
            vN[Z]= toFIXED(vU[Z]/dist);
        }
*/
        for (unsigned int ii=0; ii<3; ii++)
            pol->vntbl[i][ii]= (vN[ii]);
    }
}


bool used_textures(unsigned int textID, _MOD_DATA * model)
{
    for (unsigned int mesh=0; mesh<model->TOTAL_MESH; mesh++)
    {
        for (unsigned int i=0; i< model->pol[mesh].nbPolygon; i++)
        {
            if (model->pol[mesh].attbl[i].texno == textID)
                return true;
        }
    }
    return false;
}



void mipmap(unsigned int i)
{
    int multFactor = 2;
    if (img[i].width <= 8 || img[i].height <= 8 || img[i].width == 24) return;
    else if (img[i].width > 128 && img[i].height> 128) multFactor=4;

    if (img[i].width/multFactor % 8 != 0 || img[i].height/multFactor <= 4) return;

    img[i].height=img[i].height/multFactor;
    img[i].width=img[i].width/multFactor;
   for (unsigned int h=0; h<img[i].height; h++)
   {
       for (unsigned int w=0; w<img[i].width; w++)
       {
           img[i].data[w+h*img[i].width] = img[i].data[w*multFactor+h*multFactor*img[i].width*multFactor];
       }
   }

}

void copy_texture_for_mipmap(_MOD_DATA * model)
{
    for (unsigned short i=0; i<model->TOT_TEXT; i++)
    {
        img[i+model->TOT_TEXT].width = img[i].width;
        img[i+model->TOT_TEXT].height = img[i].height;
        TextureArray[i+model->TOT_TEXT]=TextureArray[i];

        for (unsigned int ii=0; ii< img[i].width*img[i].height; ii++)
            img[i+model->TOT_TEXT].data[ii]=img[i].data[ii];
    }
}

