/*********************************************************
* Model converter by XL2. To be used with the Z-Treme engine on the Sega Saturn.
* Compatible with Sega Graphic Libraries and JO ENGINE (with SGL enabled)
* TO DO : Code clean up (I commented out several lines for my tests with binary writing and other functions)
* TO DO : Remove the globals
* TO DO : Ditch OBJ for DAE (not easy)
* TO DO : Add animation support (maybe using OBJ and vertex interpolation)
* TO DO : Add option to pre-calculate lightning
* TO DO : More testing to find out bugs
* NOTE : IF YOU USE IT FOR YOUR GAME, GIVE ME SOME CREDIT!
***********************************/
#include "SRC/ZTM_DEF.h"

/***************************************
* UGLY UGLY GLOBALS... TO BE REMOVED SOMEDAY...
***********************************/
string PdataName[TOTAL_OBJECTS];
/**********************************/

/**TO BE MOVED ELSEWHERE (ZTM_DEF)***/
#define     LUTaddr             (0x25C7A960)
#define     returnLUTaddr(n)    (LUTaddr + (0x20 * n))
#define     LUTidx(n)           (Uint16)(62764 + (4 * n))
#define     CRAM_Base           (0x25f00200)
#define     returnCRAMaddr(n)   (CRAM_Base + (0x20 * n))
#define     LUTcramIdx(n)       ((256 + (16 * n)))
/**************************
* Gives special conditions for different textures, such as damage player, no collision, dual plane, etc.
* I leave it here for now for easier access
**************************/
void specialConditions(unsigned short startPtr, unsigned short endPtr, _MOD_DATA * model)
{
    if (model->TOT_TEXT <= 0) return;


    for (unsigned short i=startPtr; i<endPtr; i++)
    {
        std::size_t findDual = TextureArray[i].find("DUAL_");
        std::size_t findWhite = TextureArray[i].find("C_WHITE");
        if ((findDual==0) && (pimg[i].palette[1]==0 && pimg[i].palette[0]!=0))
        {
            cout << "Found a dual plane attribute texture (no backface culling)\n";
            TextureAttributeArray[i]=ATTRIBUTE(Dual_Plane, SORT_MIN, No_Texture, pimg[i].palette[0], CL32KRGB|No_Gouraud, CL32KRGB| MESHoff | Window_In, sprPolygon, UseLight|UseNearClip);
        }
        else if ((findWhite == 0) && (pimg[i].palette[1]==0 && pimg[i].palette[0]!=0))
        {
            cout << "Found a quad with SORT_MIN flag.\n";
            TextureAttributeArray[i]=ATTRIBUTE(Single_Plane, SORT_MIN, No_Texture, pimg[i].palette[0], CL32KRGB|No_Gouraud, CL32KRGB| MESHoff | Window_In, sprPolygon, UseLight|UseNearClip);
        }
        else if (pimg[i].palette[0]==0)
        {
           TextureAttributeArray[i] = ATTRIBUTE(Dual_Plane,SORT_CEN, i, LUTidx(i), No_Gouraud,Window_In|MESHoff|HSSon|ECdis|SPenb|CL16Look,sprNoflip,UseLight);
        }
        else
        {
            if (pimg[i].palette[1]==0 && pimg[i].palette[0]!=0)
                TextureAttributeArray[i]=ATTRIBUTE(Single_Plane, SORT_CEN, No_Texture, pimg[i].palette[0], CL32KRGB|No_Gouraud, CL32KRGB| MESHoff | Window_In, sprPolygon, UseLight|UseNearClip);
                //TextureAttributeArray[i]=ATTRIBUTE(Single_Plane, SORT_CEN, No_Texture, pimg[i].palette[0], CL16Bnk|No_Gouraud, CL16Bnk| MESHoff | Window_In, sprPolygon, UseLight|UseNearClip);
              //  TextureAttributeArray[i] = ATTRIBUTE(Single_Plane, SORT_CEN, No_Texture, pimg[i].palette[0], CL32KRGB | No_Gouraud, CL32KRGB|Window_In|MESHoff , sprPolygon, UseLight);
            else
                TextureAttributeArray[i] = ATTRIBUTE(Single_Plane,SORT_CEN, i, LUTidx(i), No_Gouraud,Window_In|MESHoff|HSSon|ECdis|SPdis|CL16Look,sprNoflip,UseLight|UseNearClip);
        }


    }
}


/************
* MAIN FUNCTION : USE OBJ2SGL WITH THE 1) IMPORT FOLDER 2) .OBJ FILE NAME WITHOUT EXTENSION 3)SCALE FACTOR
* SCALE FACTOR : TO SCALE THE OBJECT WITHOUT HAVING TO GO BACK TO THE 3D MODELING TOOL. Integers only
*************/
int main()
{

    vector3 scaleFactor;

    string path;
    int32_t scale;

    cout << "SEGA SATURN Z-TREME ENGINE MODEL CONVERTER 0.1\n";
    cout << "BY XL2 (2018-05-28)\n\n";
    cout << "This program was quickly coded, if you have bugs, don't hesitate to tell me!\nNew in this update : animation support!\n\n";

    _MOD_DATA newModel;

    cout << "\n***STEP 1***";
    cout << "\n   Enter how many keyframes your model has\n";
    cout <<"   Example : for 6 keyframes to interpolate your animations, enter 6.\n   0 for no animation.\n\n";
    cout << "ENTER TOTAL KEYFRAMES : ";
    cin >> newModel.nbFrames;

    if (newModel.nbFrames == 0)
    {
        newModel.framerate=0;
        cout << "\n***STEP 2 SKIPPED***";
        cout << "\n   You will have the option later to reorder your model to allow matrix animation.\n";
    }

    else
    {
        cout << "\n***STEP 2***";
        cout << "\n   Enter how many frames you want to interpolate between each keyframe at 60 fps. Power of 2 values as in ''1 << value''.\n";
        cout << "   Example : ''0'' = 1 frame, ''1'' = 2 frames, ''2'' = 4 frames, etc.\n   Note : It will affect the loaded filenames\n\n";
        cout << "ENTER INTERPOLATION FACTOR : ";
        cin >> newModel.framerate;
    }

    cout << "\n***STEP 3***";
    cout << "\n   You will now have to enter the scale value and press enter. \n   Example : 64, 128, 100 or any integer value\n\n";
    cout << "ENTER SCALE : ";
    cin >> scale;

    scaleFactor.x = scale;    scaleFactor.y = scale;    scaleFactor.z = scale;

    cout << "\n***STEP 4***";
    cout << "\n   You will now have to enter the folder's relative path\n   IMPORTANT : Don't forget to end it with a '/'.\n   Example : IN/TITLE/  and then press enter.\n\n";
    cout << "ENTER THE PATH : ";
    cin >> path;
    cout << "\n";

    string fileName;
    cout << "\n***STEP 5***\n";
    cout << "\n   You will now have to enter the OBJ filename WITHOUT the extension.\n   Example : TITLE and then press enter.\n\n";
    cout << "ENTER THE NAME : ";
    cin >> fileName;

    //newModel.animation = new anim_struct[newModel.nbFrames];
    newModel.animation = new key_frame_t[newModel.nbFrames];
    LoadOBJ(path, fileName, scaleFactor, &newModel);
    delete [] newModel.animation;

    cout << "End of program. Enjoy!\n\n";

    //cin >> ansCIN;
    return 7;
}




